# AWS::IoT::DomainConfiguration generated from spec 20.1.0
use Moose::Util::TypeConstraints;

coerce 'Cfn::Resource::Properties::AWS::IoT::DomainConfiguration',
  from 'HashRef',
   via { Cfn::Resource::Properties::AWS::IoT::DomainConfiguration->new( %$_ ) };

package Cfn::Resource::AWS::IoT::DomainConfiguration {
  use Moose;
  extends 'Cfn::Resource';
  has Properties => (isa => 'Cfn::Resource::Properties::AWS::IoT::DomainConfiguration', is => 'rw', coerce => 1);
  
  sub AttributeList {
    [ 'Arn','DomainType','ServerCertificates' ]
  }
  sub supported_regions {
    [ 'us-east-1' ]
  }
}



subtype 'Cfn::Resource::Properties::AWS::IoT::DomainConfiguration::Tags',
     as 'Cfn::Value';

coerce 'Cfn::Resource::Properties::AWS::IoT::DomainConfiguration::Tags',
  from 'HashRef',
   via {
     if (my $f = Cfn::TypeLibrary::try_function($_)) {
       return $f
     } else {
       return Cfn::Resource::Properties::Object::AWS::IoT::DomainConfiguration::Tags->new( %$_ );
     }
   };

package Cfn::Resource::Properties::Object::AWS::IoT::DomainConfiguration::Tags {
  use Moose;
  use MooseX::StrictConstructor;
  extends 'Cfn::Value::TypedValue';
  
  has Tags => (isa => 'ArrayOfCfn::Resource::Properties::TagType', is => 'rw', coerce => 1, traits => [ 'CfnMutability' ], mutability => 'Mutable');
}

subtype 'Cfn::Resource::Properties::AWS::IoT::DomainConfiguration::ServerCertificateSummary',
     as 'Cfn::Value';

coerce 'Cfn::Resource::Properties::AWS::IoT::DomainConfiguration::ServerCertificateSummary',
  from 'HashRef',
   via {
     if (my $f = Cfn::TypeLibrary::try_function($_)) {
       return $f
     } else {
       return Cfn::Resource::Properties::Object::AWS::IoT::DomainConfiguration::ServerCertificateSummary->new( %$_ );
     }
   };

package Cfn::Resource::Properties::Object::AWS::IoT::DomainConfiguration::ServerCertificateSummary {
  use Moose;
  use MooseX::StrictConstructor;
  extends 'Cfn::Value::TypedValue';
  
  has ServerCertificateArn => (isa => 'Cfn::Value::String', is => 'rw', coerce => 1, traits => [ 'CfnMutability' ], mutability => 'Mutable');
  has ServerCertificateStatus => (isa => 'Cfn::Value::String', is => 'rw', coerce => 1, traits => [ 'CfnMutability' ], mutability => 'Mutable');
  has ServerCertificateStatusDetail => (isa => 'Cfn::Value::String', is => 'rw', coerce => 1, traits => [ 'CfnMutability' ], mutability => 'Mutable');
}

subtype 'Cfn::Resource::Properties::AWS::IoT::DomainConfiguration::AuthorizerConfig',
     as 'Cfn::Value';

coerce 'Cfn::Resource::Properties::AWS::IoT::DomainConfiguration::AuthorizerConfig',
  from 'HashRef',
   via {
     if (my $f = Cfn::TypeLibrary::try_function($_)) {
       return $f
     } else {
       return Cfn::Resource::Properties::Object::AWS::IoT::DomainConfiguration::AuthorizerConfig->new( %$_ );
     }
   };

package Cfn::Resource::Properties::Object::AWS::IoT::DomainConfiguration::AuthorizerConfig {
  use Moose;
  use MooseX::StrictConstructor;
  extends 'Cfn::Value::TypedValue';
  
  has AllowAuthorizerOverride => (isa => 'Cfn::Value::Boolean', is => 'rw', coerce => 1, traits => [ 'CfnMutability' ], mutability => 'Mutable');
  has DefaultAuthorizerName => (isa => 'Cfn::Value::String', is => 'rw', coerce => 1, traits => [ 'CfnMutability' ], mutability => 'Mutable');
}

package Cfn::Resource::Properties::AWS::IoT::DomainConfiguration {
  use Moose;
  use MooseX::StrictConstructor;
  extends 'Cfn::Resource::Properties';
  
  has AuthorizerConfig => (isa => 'Cfn::Resource::Properties::AWS::IoT::DomainConfiguration::AuthorizerConfig', is => 'rw', coerce => 1, traits => [ 'CfnMutability' ], mutability => 'Mutable');
  has DomainConfigurationName => (isa => 'Cfn::Value::String', is => 'rw', coerce => 1, traits => [ 'CfnMutability' ], mutability => 'Immutable');
  has DomainConfigurationStatus => (isa => 'Cfn::Value::String', is => 'rw', coerce => 1, traits => [ 'CfnMutability' ], mutability => 'Mutable');
  has DomainName => (isa => 'Cfn::Value::String', is => 'rw', coerce => 1, traits => [ 'CfnMutability' ], mutability => 'Immutable');
  has ServerCertificateArns => (isa => 'Cfn::Value::Array|Cfn::Value::Function|Cfn::DynamicValue', is => 'rw', coerce => 1, traits => [ 'CfnMutability' ], mutability => 'Immutable');
  has ServiceType => (isa => 'Cfn::Value::String', is => 'rw', coerce => 1, traits => [ 'CfnMutability' ], mutability => 'Immutable');
  has Tags => (isa => 'Cfn::Resource::Properties::AWS::IoT::DomainConfiguration::Tags', is => 'rw', coerce => 1, traits => [ 'CfnMutability' ], mutability => 'Mutable');
  has ValidationCertificateArn => (isa => 'Cfn::Value::String', is => 'rw', coerce => 1, traits => [ 'CfnMutability' ], mutability => 'Immutable');
}

1;
### main pod documentation begin ###

=encoding UTF-8

=head1 NAME

Cfn::Resource::AWS::IoT::DomainConfiguration - Cfn resource for AWS::IoT::DomainConfiguration

=head1 DESCRIPTION

This module implements a Perl module that represents the CloudFormation object AWS::IoT::DomainConfiguration.

See L<Cfn> for more information on how to use it.

=head1 AUTHOR

    Jose Luis Martinez
    CAPSiDE
    jlmartinez@capside.com

=head1 COPYRIGHT and LICENSE

Copyright (c) 2013 by CAPSiDE
This code is distributed under the Apache 2 License. The full text of the 
license can be found in the LICENSE file included with this module.

=cut
